function volumeOut = backwardXLFMm(projection, PSF_A, PSF_B, RatioAB, ROISize)


Nxy=size(PSF_A,1);
Nz=size(PSF_A,3);

NxyAdd=round((Nxy/RatioAB-Nxy)/2);
NxySub=round(Nxy*(1-RatioAB)/2)+NxyAdd;

gpuTmp1 = gpuArray(complex(single(zeros(Nxy+NxyAdd*2,Nxy+NxyAdd*2))));
gpuTmp2 = gpuArray(single(zeros(Nxy+NxyAdd*2,Nxy+NxyAdd*2)));

volumeOut = zeros(2*ROISize, 2*ROISize, Nz, 'single', 'gpuArray');
for jj=1:Nz
    gpuTmp1(NxyAdd+1:end-NxyAdd,NxyAdd+1:end-NxyAdd)=fftshift(fft2(projection).*conj(fft2(ifftshift(single(gpuArray(PSF_B(:,:,jj)))))));
    gpuTmp2(NxySub+1:end-NxySub,NxySub+1:end-NxySub)=abs(ifft2(ifftshift(gpuTmp1(NxySub+1:end-NxySub,NxySub+1:end-NxySub))));
    gpuTmp3=(max(real(ifft2(fft2(projection).*conj(fft2(ifftshift(single(gpuArray(PSF_A(:,:,jj)))))))),0)+gpuTmp2(NxyAdd+1:end-NxyAdd,NxyAdd+1:end-NxyAdd))/2;
    volumeOut(:,:,jj)= (gpuTmp3(Nxy/2-ROISize+1:Nxy/2+ROISize,Nxy/2-ROISize+1:Nxy/2+ROISize));


end
volumeOut = gather(volumeOut);