function projection = forwardXLFM(volumeIn, PSF_A, PSF_B, RatioAB, ROISize)


Nxy=size(PSF_A,1);
Nz=size(PSF_A,3);

NxyAdd=round((Nxy/RatioAB-Nxy)/2);
gpuTmp1=gpuArray(complex(single(zeros(Nxy+NxyAdd*2,Nxy+NxyAdd*2))));
gpuObjReconTmp=zeros(Nxy,Nxy,'single','gpuArray');

ImgEst=zeros(Nxy,Nxy,'single','gpuArray');
for jj=1:Nz
    gpuObjReconTmp(Nxy/2-ROISize+1:Nxy/2+ROISize,Nxy/2-ROISize+1:Nxy/2+ROISize)=gpuArray(volumeIn(:,:,jj));
    gpuTmp1(NxyAdd+1:end-NxyAdd,NxyAdd+1:end-NxyAdd)=fftshift(fft2(gpuObjReconTmp));
    gpuTmp2=abs(ifft2(ifftshift(gpuTmp1)));
    ImgEst=ImgEst+max(real(ifft2(fft2(ifftshift(single(PSF_A(:,:,jj)))).*fft2(gpuObjReconTmp))),0)...
        +max(real(ifft2(fft2(ifftshift(single(PSF_B(:,:,jj)))).*fft2(gpuTmp2(NxyAdd+1:end-NxyAdd,NxyAdd+1:end-NxyAdd)))),0);
end
projection = gather(ImgEst);